<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'
// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);

document.addEventListener("DOMContentLoaded", function () {
  // Obtener la tabla DataTable
  const dataTable = $('#datatable-index-particulares').DataTable();

  // Agregar un evento de clic a los elementos con la clase "eliminar" dentro de la tabla
  dataTable.on("click", ".sancionar", function (rfc) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const rfc = rowData.rfc;
      window.location.href = route('sanciones.create.particulares', {rfc:rfc});
    }
  });


  dataTable.on("click", ".detalles", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id;
      window.location.href = route('particulares.show',id);
    }
  });


});

export default {
  components: { DataTable, Multiselect },
  data() {
    return {
      products: null,
      fechaInicial:'',
      fechaFinal: '',
      rango:'',
      sancionesIds: '',
      InstitucionesIds:'',
      faltaIds:'',
      responsableSancionIds:'',
      rfc:'',
      admin:this.variables.sancionesAdd,

      TipoFalta: [],
	      Faltas:this.variables && this.variables.tiposFalta
	      ? this.variables.tiposFalta.map(item => item)
	      : [],

        ResponsableSancion: null,
	      Responsables:this.variables && this.variables.responsablesSancion
	      ? this.variables.responsablesSancion.map(item => item)
	      : [],
      


      InstitucionSancionadora: [],
	      OpcionesInstituciones: this.variables && this.variables.institucionesDependencias
	      ? this.variables.institucionesDependencias.map(item => item)
	      : [],

        TiposSancion: [],
	      Sanciones: this.variables && this.variables.tiposSancion
	      ? this.variables.tiposSancion.map(item => item)
	      : [],
        TiposSancionSeleccionados: [],
        columns: [
        { data: null, render: function (data, type, row, meta) { return `${meta.row + 1}` } },
        { data: 'rfc',}, // Habilitar búsqueda en esta columna
        { data: 'tipoPersona.valor'}, 
         { data: 'nombreRazonSocial',},
        { data: 'sancionesCount'}, 
        {
  data: null,
  render: (data, type, row) => {
    if (this.admin == true) {
      return '<a title="Detalles" href="#a" v-if="puedeVerDetalles" v-on:click="detalles(id)" class="detalles text-warning"><i class=" mdi mdi-eye font-size-18"></i></a> <a href="#a" v-on:click="sancionar(rfc)" class="sancionar text-info" title="Sancionar"><i class="mdi mdi-clipboard-text font-size-20"></i></a>';
    } else {
      return '<a title="Detalles" href="#a" v-if="puedeVerDetalles" v-on:click="detalles(id)" class="detalles text-warning"><i class=" mdi mdi-eye font-size-18"></i></a>';
    }
  }
}
      ],
      botones: [
        {
          title: 'Reporte de particulares',
          extend: 'excelHtml5',
          text: '<i class ="far fa-file-excel"></i> Descargar Excel',
          className: 'btn btn-success',
          exportOptions: {
        columns: [1,2, 3, 4, 5] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
        }
      ]
    }
  },

  mounted() {
    const dataTable = $('#datatable-index-particulares').DataTable();
    this.getProducts();
    this.initDataTable();
  },

  props: {
	    variables: Object,
	},

  watch: {
	 
   TiposSancionSeleccionados: function(newValue) {
     
   // Obtener los IDs de las opciones seleccionadas
   const selectedIds = newValue.map(option => {
     const selectedOption = this.Sanciones.find(sancion => sancion.valor === option);
     return selectedOption ? selectedOption.id : null;
   });


   const selectedNombres = newValue.map(option => {
   const selectedOption = this.Sanciones.find(sancion => sancion.valor === option);
   return selectedOption ? selectedOption.valor : null;
   });

 
   this.sancionesNombre = selectedNombres
   this.sancionesIds = selectedIds;

   console.log(this.sancionesNombre);
   console.log(this.sancionesIds);
 
 },

 TipoFalta: function(newValue) {
     
     // Obtener los IDs de las opciones seleccionadas
     const selectedIds = newValue.map(option => {
       const selectedOption = this.Faltas.find(falta => falta.valor === option);
       return selectedOption ? selectedOption.id : null;
     });
 
 
     const selectedNombres = newValue.map(option => {
     const selectedOption = this.Faltas.find(falta => falta.valor === option);
     return selectedOption ? selectedOption.valor : null;
     });
 
   
     this.sancionesNombre = selectedNombres
     this.faltaIds = selectedIds;
 
     console.log(this.sancionesNombre);
     console.log(this.faltaIds);
   
   },

   InstitucionSancionadora: function(newValue) {
     
     // Obtener los IDs de las opciones seleccionadas
     const selectedIds = newValue.map(option => {
       const selectedOption = this.OpcionesInstituciones.find(institucion => institucion.nombre === option);
       return selectedOption ? selectedOption.id : null;
     });
 
 
     const selectedNombres = newValue.map(option => {
     const selectedOption = this.OpcionesInstituciones.find(institucion => institucion.nombre === option);
     return selectedOption ? selectedOption.nombre : null;
     });
 
   
     this.sancionesNombre = selectedNombres
     this.InstitucionesIds = selectedIds;
 
     console.log(this.sancionesNombre);
     console.log(this.InstitucionesIds);
   
   },

   ResponsableSancion: function(newValue) {
     
     // Obtener los IDs de las opciones seleccionadas
     const selectedIds = newValue.map(option => {
       const selectedOption = this.Responsables.find(responsable => responsable.nombreCompleto === option);
       return selectedOption ? selectedOption.id : null;
     });
 
 
     const selectedNombres = newValue.map(option => {
     const selectedOption = this.Responsables.find(responsable => responsable.nombreCompleto === option);
     return selectedOption ? selectedOption.nombreCompleto : null;
     });
 
   
     this.sancionesNombre = selectedNombres
     this.responsableSancionIds = selectedIds;
 
     console.log(this.sancionesNombre);
     console.log(this.responsableSancionIds);
   
   },

 },

  methods: {
    getProducts() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
  axios.get(route('particulares.get.all')).then(
        response => {
          swal.close()
          this.products = response.data.data
        }
      )
    },

    
    filtroBusqueda() {

swal({
icon: 'info',
text: 'Cargando registros...',
buttons: false,
closeOnClickOutside: false,
closeOnEsc: false,
});





const dataTable = $('#datatable-index-particulares').DataTable({

dom: 'Bfrtip', // Agrega el contenedor de botones
buttons: [
{
extend: 'excelHtml5', // Extensión para exportar a Excel
title: 'Lista de Servidores Publicos', // Título del archivo Excel
text: '<i class ="mdi mdi-file-excel"></i> Descargar Excel',
className: 'btn btn-success',
exportOptions: {
columns: [1,2, 3,] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
}
},
],
destroy: true,
serverSide: true,
ajax: {
url: route('particulares.get.all', {rfc:this.rfc}),
type: 'GET',
dataSrc: function (json) {
json.recordsTotal = json.total;
json.recordsFiltered = json.total;
return json.data;

},
data: d => {
d.page = (d.start / d.length) + 1;
},
},
columns: this.columns,

searching: true,




language: {
processing: "Procesando...",
search: "Buscar:",
lengthMenu: "Mostrar _MENU_ registros",
info: "Mostrando desde _START_ al _END_ de _TOTAL_ registros",
infoEmpty: "Mostrando ningún elemento.",
infoFiltered: "(filtrado _MAX_ elementos total)",
infoPostFix: "",
loadingRecords: "Cargando registros...",
zeroRecords: "No se encontraron registros",
emptyTable: "No hay datos disponibles en la tabla",
paginate: {
first: "Primero",
previous: "Anterior",
next: "Siguiente",
last: "Último"
},
aria: {
sortAscending: ": activar para ordenar la columna ascendente",
sortDescending: ": activar para ordenar la columna descendente"
}
},

});
this.bindTableEvents(dataTable);

},

initDataTable() {
    const dataTable = $('#datatable-index-particulares').DataTable({

      dom: 'Bfrtip', // Agrega el contenedor de botones
    buttons: [
      {
        extend: 'excelHtml5', // Extensión para exportar a Excel
        title: 'Reporte de sanciones a Servidores Publicos', // Título del archivo Excel
        text: '<i class ="mdi mdi-file-excel"></i> Descargar Excel',
        className: 'btn btn-success',
        exportOptions: {
        columns: [1,2, 3, 4, 5] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
      },
    ],
      destroy: true,
      serverSide: true,
      ajax: {
        url: route('particulares.get.all'),
        type: 'GET',
        dataSrc: function (json) {
            json.recordsTotal = json.total;
            json.recordsFiltered = json.total;
            return json.data;
        },
        data: d => {
          d.page = (d.start / d.length) + 1;
        },
      },
      columns: this.columns,

      searching: true,

      
      

      language: {
          processing: "Procesando...",
          search: "Buscar:",
          lengthMenu: "Mostrar _MENU_ registros",
          info: "Mostrando desde _START_ al _END_ de _TOTAL_ registros",
          infoEmpty: "Mostrando ningún elemento.",
          infoFiltered: "(filtrado _MAX_ elementos total)",
          infoPostFix: "",
          loadingRecords: "Cargando registros...",
          zeroRecords: "No se encontraron registros",
          emptyTable: "No hay datos disponibles en la tabla",
          paginate: {
            first: "Primero",
            previous: "Anterior",
            next: "Siguiente",
            last: "Último"
          },
          aria: {
            sortAscending: ": activar para ordenar la columna ascendente",
            sortDescending: ": activar para ordenar la columna descendente"
          }
        },
      
    });

    
    
    dataTable.on('page.dt', () => {
      swal({
        icon: 'info',
        text: 'Cargando registros...',
        buttons: false,
        closeOnClickOutside: false,
        closeOnEsc: false,
      });
    });

    

    // Añadir un event listener para el evento 'draw'.
    dataTable.on('draw.dt', () => {
      setTimeout(() => {
    swal.close();
  }, 4000);
    });
  },

  bindTableEvents(dataTable) {
    dataTable.on("click", ".sancionar", function (rfc) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const rfc = rowData.rfc;
      window.location.href = route('sanciones.create.particulares', {rfc:rfc});
    }
  });


  dataTable.on("click", ".detalles", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id;
      window.location.href = route('particulares.show',id);
    }
  });
},



    create: function (event) {
      window.location.href = '/sanciones/create/particulares';

    }
  }
}
</script>

<template>

        <div class="row">
          <div class="col-lg-12">
            <div class="card">
              <div class="card-body">
                <div class=" d-grid gap-2 d-md-flex justify-content-md-end dropdown float-end">
                  <button type="button" v-on:click="create" id="btn-registrar" v-if="can('sanciones.add')" class="btn btn-info waves-effect">
                    <i class="bx bx-add-to-queue font-size-16 align-middle me-2"></i> Registrar sancion
                  </button>
                  <button type="button" id="btn-registrar" data-bs-toggle="modal" data-bs-target=".bs-example-modal-xl" class="btn btn-primary waves-effect">
                    <i class="mdi mdi-filter font-size-16 align-middle me-2 "></i> Filtros de busqueda
                  </button>
                </div>

                <div class="modal fade bs-example-modal-xl" style="margin-left: 100px;" tabindex="-1" role="dialog" aria-labelledby="myExtraLargeModalLabel" aria-hidden="true">
                  <div class="modal-dialog modal-xl">
                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title">Filtros de busqueda</h5>
                                        </div>
                                        <div class="modal-body">
                                          <div class="row">
                                              <div class="col-md-20">
                                                <div class="mb-3">
                                                  <label for="validationCustom03" class="form-label">RFC</label>
                                                  <div class="input-group">
                                                    <input name="" type="text" class="form-control" id="validationCustom03" placeholder="RFC" v-model="rfc"/>
                                                    </div> 
                                                  </div>
                                              </div>
                                          </div>
  
                                          <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                                            <button class="btn btn-danger" data-bs-dismiss="modal" aria-label="Close" type="button">Cancelar</button>
                                            <button class="btn btn-primary" data-bs-dismiss="modal" aria-label="Close" @click="filtroBusqueda"  type="submit">Buscar</button>
                                          </div>
  
                                         
  
                                        </div>
                                    </div>
                                </div>
                            </div>




                <h4 class="card-title mb-4">Lista de particulares</h4>
                <div class="table-responsive">
                  <DataTable :data="products" :columns="columns" id="datatable-index-particulares" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
                    :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                      search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                      info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                      infoFiltered: '(Filtrados de _MAX_ registros.)',
                      paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
                    }, buttons:botones}">
                    <thead class="table-light">
                      <tr>
                        <th style="width: 1%">
                        </th>
                        <th class="align-middle text-center" style="width: 20%;">RFC</th>
                        <th class="align-middle text-center" style="width: 10%;">Tipo persona</th>
                        <th class="align-middle text-center" style="width: 30%;">Nombre</th>
                        <th class="align-middle text-center" style="width: 20%;">Sanciones</th>
                        <th class="align-middle text-center" style="width: 10%;">Acciones</th>
                      </tr>
                    </thead>
                    <tbody style="text-align: center; font-size: 15px;"></tbody>
                  </DataTable>
                </div>
              </div>
            </div>
          </div>
        </div>
      
    <footer class="footer"></footer>

</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_filter{
  display: none;
}

#datatable-index-particulares{
  margin-top: 10px;
}


.dt-buttons btn-group {
  background-color: red;
}

@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>
